on startMovie
  if the quickTimePresent = 0 then
    alert("Please install the version of QuickTime provided before running Days of Rage.")
    quit()
  end if
  if the colorDepth <> 8 then
  end if
  set the exitLock to 1
  initDoRGlobals()
end

on initDoRGlobals
  global gPicSort, gCDName, gCurrPicNum, gMidStage, gCapViewCastNum, gBg, gSoundSet, gSoundPlaying, gSoundCast, gDirSep, gBlendSpriteList, gAuto, gCapUp, gCapClix, gSlideDelay, gCurrChart, gFlasherRate, gFlasherCount, gJumpList, gIntroMovLength, gMainClickOff, gKnockBack
  if the machineType < 256 then
    set gDirSep to ":"
    set gCDName to the pathName & "dor2" & gDirSep
  else
    set gDirSep to "\"
    set gCDName to the pathName
  end if
  set gPicSort to "Editorial"
  set gCurrPicNum to 0
  set gCurrChart to 5
  set the hilite of cast "OptionSpeech" to 1
  set gMidStage to (the stageRight - the stageLeft) / 2
  set gBlendSpriteList to list(39, 40, 41, 42, 43, 44)
  set gSoundCast to 12
  set gSoundSet to EMPTY
  set gSoundPlaying to 0
  set gKnockBack to 0
  set gMainClickOff to 0
  set gCapViewCastNum to 11
  set gAuto to 0
  set gCapUp to 0
  set gCapClix to 0
  set gSlideDelay to 1
  set gFlasherRate to 10
  set gFlasherCount to 0
  set gJumpList to []
  set the timeoutScript to EMPTY
  set gIntroMovLength to the duration of cast "INTRO.MOV" / 60
  put string(gIntroMovLength / 60) & ":" && string(gIntroMovLength mod 60) into field "d"
  set gIntroMovLength to 0
  puppetSprite(39, 1)
  puppetSprite(40, 1)
  puppetSprite(41, 1)
  puppetSprite(42, 1)
  puppetSprite(43, 1)
  puppetSprite(44, 1)
  set the visible of sprite 39 to 0
  set the visible of sprite 40 to 0
  set the visible of sprite 41 to 0
  set the visible of sprite 42 to 0
  set the visible of sprite 43 to 0
  set the visible of sprite 44 to 0
  set the castNum of sprite 39 to 2
  set the castNum of sprite 40 to 3
  set the castNum of sprite 41 to 4
  set the castNum of sprite 42 to 5
  set the castNum of sprite 43 to 7
  set the castNum of sprite 44 to 8
  updateStage()
end

on initBg
  global gBg
  if factory("RearWindow") = 0 then
    openXLib("RearWindow.XObj")
  end if
  if objectp(gBg) then
    gBg(mdispose)
  end if
  set gBg to RearWindow(mnew, "S")
  if value(gBg) < 0 then
    alert("Sorry, system error" && string(gBg) && "(RearWindow).")
    quit()
  else
    set ramNeed to gBg(mGetMemoryNeeded)
    if the freeBlock < ramNeed then
      alert("Sorry, not enough RAM:" && string(ramNeed) && "bytes needed.")
      quit()
    else
      gBg(mPatToWindow, -5)
    end if
  end if
end

on imagePrevNext
  global gCurrPicNum, gPicSort, gMidStage, gYearIndex
  if gPicSort = "Editorial" then
    if the mouseH > gMidStage then
      if gCurrPicNum > 0 then
        getNextEditMain()
      else
        getNextEditMain()
      end if
    else
      if gCurrPicNum > 1 then
        getPrevEditMain()
      else
        getNextEditMain()
      end if
    end if
  else
    if the mouseH > gMidStage then
      getNextTimeMain()
    else
      getPrevTimeMain()
    end if
  end if
end

on getPrevTimeMain
  global gYearIndex, gYearData, gCurrPicNum
  cursor(4)
  if gYearIndex <= 1 then
    set gYearIndex to count(gYearData)
    set gCurrPicNum to getAt(gYearData, gYearIndex)
  else
    set gYearIndex to gYearIndex - 1
    set gCurrPicNum to getAt(gYearData, gYearIndex)
  end if
  getMain()
end

on getNextTimeMain
  global gYearIndex, gYearData, gCurrPicNum
  cursor(4)
  if count(gYearData) = gYearIndex then
    set gCurrPicNum to getAt(gYearData, 1)
    set gYearIndex to 1
  else
    set gYearIndex to gYearIndex + 1
    set gCurrPicNum to getAt(gYearData, gYearIndex)
  end if
  getMain()
end

on getPrevEditMain
  global gCurrPicNum
  set curr to getPos([6, 15, 26, 33, 46, 59], gCurrPicNum)
  if curr > 1 then
    set index to curr - 1
  else
    set index to 6
  end if
  set gCurrPicNum to getAt([6, 15, 26, 33, 46, 59], index)
  cursor(4)
  abortSound()
  duplicate(cast integer(index + 519), 9)
end

on getNextEditMain
  global gCurrPicNum
  set curr to getPos([6, 15, 26, 33, 46, 59], gCurrPicNum)
  if curr < 6 then
    set index to curr + 1
  else
    set index to 1
  end if
  set gCurrPicNum to getAt([6, 15, 26, 33, 46, 59], index)
  cursor(4)
  abortSound()
  duplicate(cast integer(index + 519), 9)
end

on getMain
  global gCurrPicNum
  cursor(4)
  abortSound()
  duplicate(cast integer(gCurrPicNum + 519), 9)
end

on setSound theSoundPath
  global gSoundCast
  importFileInto(cast gSoundCast, theSoundPath)
end

on introOff
  go("IntroOff")
end

on scanSndDir whichDir
  global gCDName, gDirSep, gLebOrIs
  set p to gCDName & "Audio" & gLebOrIs & gDirSep & whichDir & gDirSep
  set count to 1
  set aifcount to 0
  set cont to EMPTY
  repeat while 1 = 1
    set var to getNthFileNameInFolder(p, count)
    if var = EMPTY then
      exit repeat
    else
      if var contains ".AIF" then
        set aifcount to aifcount + 1
        put p & var into line aifcount of cont
      end if
    end if
    set count to count + 1
  end repeat
  return cont
end

on checkSound
  global gSoundSet, gSoundPlaying, gSoundCast
  if soundBusy(1) = 0 then
    if gSoundSet <> EMPTY then
      if (gSoundPlaying + 1) <= the number of lines in gSoundSet then
        set gSoundPlaying to gSoundPlaying + 1
        setSound(line gSoundPlaying of gSoundSet)
        puppetSound(the name of cast gSoundCast)
        updateStage()
      else
        set gSoundPlaying to 0
        set gSoundSet to EMPTY
      end if
    end if
  end if
end

on abortSound
  global gSoundSet, gSoundPlaying
  puppetSound(0)
  updateStage()
  set gSoundPlaying to 0
  set gSoundSet to EMPTY
end

on pauseSnd
  global gCDName, gSoundCast
  set theSoundPath to gCDName & "HALFSEC.AIF"
  setSound(theSoundPath)
  puppetSound(the name of cast gSoundCast)
  updateStage()
  repeat while soundBusy(1)
    nothing()
  end repeat
end

on myslideDelay
  global gSlideDelay
  if gSlideDelay > 0 then
    repeat with x = 1 to gSlideDelay
      set t to getSec(t)
      repeat while getSec(t) = t
        if the mouseDown = 1 then
          exit repeat
        end if
      end repeat
      if the mouseDown = 1 then
        exit repeat
      end if
    end repeat
  end if
end

on getSec
  set the itemDelimiter to ":"
  set t to item 3 of the long time
  set the itemDelimiter to ","
  delete char 3 to length(t) of t
  if char 1 of t = "0" then
    delete char 1 of t
  end if
  return t
end

on autoOff
  global gAuto, gCapUp, gPicSort
  if the frameLabel = "M2" then
    set gAuto to 0
    set the mouseUpScript to EMPTY
    set the locH of sprite 46 to -1000
    updateStage()
    puppetSprite(46, 0)
    abortSound()
    set gCapUp to 0
    dontPassEvent()
  end if
end

on getGlossaryEntry
  global gCurrGlossary, gDirSep, gFileIOObj, gCDName, gTextHasMap
  set gTextHasMap to 0
  tacticalOff()
  set whichFile to item 1 of line gCurrGlossary of the text of cast "GlossaryIndex"
  set p to gCDName & "TEXT" & gDirSep & whichFile
  if item 3 of line gCurrGlossary of the text of cast "GlossaryIndex" = "TRUE" then
    tactical()
    set gTextHasMap to 1
  else
    tacticalOff()
  end if
end

on tactical
  puppetSprite(17, 1)
  puppetSprite(18, 1)
  set the castNum of sprite 17 to the number of member "ShowTactical"
  set the locV of sprite 18 to -1000
  updateStage()
end

on tacticalOff
  tacticalHide()
  set the locV of sprite 18 to the top of sprite 17
  updateStage()
  puppetSprite(17, 0)
  puppetSprite(18, 0)
end

on tacticalShow
  puppetSprite(30, 1)
  set the locV of sprite 30 to the locV of sprite 16
  set the castNum of sprite 17 to the number of member "HideTactical"
  updateStage()
end

on tacticalHide
  set the locV of sprite 30 to -1000
  set the castNum of sprite 17 to the number of member "ShowTactical"
  updateStage()
  puppetSprite(30, 0)
end

on EditToMain
  global gCurrPicNum
  if the clickOn <> 5 then
    set index to getOne([6, 15, 26, 33, 46, 59], gCurrPicNum)
    if index <> 0 then
      set offsetFrom519 to index
      cursor(4)
      set the mouseUpScript to EMPTY
      duplicate(cast integer(offsetFrom519 + 519), 9)
      go("M2")
    else
      beep()
    end if
  end if
end

on CreditsToContents
  set the mouseUpScript to EMPTY
  set the movieTime of sprite 10 to 0
  set the movieTime of sprite 9 to 0
  updateStage()
  go("CR")
end

on flsh
  global gCurrPicNum, gFlasherCount, gFlasherRate
  set it to line gCurrPicNum of field "MapLocs"
  set h to integer(item 1 of it)
  set v to integer(item 2 of it)
  puppetSprite(47, 1)
  if gFlasherCount <= 0 then
    if the locH of sprite 47 = h then
      set the locH of sprite 47 to -1000
      set the locV of sprite 47 to 0
    else
      set the locH of sprite 47 to h
      set the locV of sprite 47 to v
    end if
    set gFlasherCount to gFlasherRate
  else
    set gFlasherCount to gFlasherCount - 1
  end if
end

on MapToMain
  set the mouseUpScript to EMPTY
  set the locH of sprite 47 to -1000
  set the locV of sprite 47 to 0
  puppetSprite(47, 0)
  puppetSprite(3, 0)
  updateStage()
  go("M2")
  if the clickOn = 44 then
    hideem(44)
    doContents()
  else
    if the clickOn = 43 then
      hideem(43)
      doThumbs()
    else
      if the clickOn = 42 then
        nothing()
      else
        if the clickOn = 41 then
          LebaneseSnd()
        else
          if the clickOn = 40 then
            israeliSnd()
          else
            if the clickOn = 39 then
              doCaption2()
            end if
          end if
        end if
      end if
    end if
  end if
end

on MovieToContents
  cursor(4)
  unLoadCast(104)
  puppetTransition(23)
  go("Contents")
end

on HereToContents
  set the mouseUpScript to EMPTY
  go("Contents")
end

on AboutToContents
  set the mouseUpScript to EMPTY
  go("Contents")
end

on SplashToContents
  puppetSound(0)
  puppetSprite(2, 0)
  puppetSprite(3, 0)
  updateStage()
  set the mouseUpScript to EMPTY
  go("pc")
end

on mapIconOff
  set the locH of sprite 47 to -1000
  set the locV of sprite 47 to 0
  updateStage()
  puppetSprite(47, 0)
end

on blendOn spr, rate
  puppetSprite(spr, 1)
  set the ink of sprite spr to 32
  set the blend of sprite spr to 0
  updateStage()
  set jump to integer(100 / rate)
  repeat with x = 1 to rate
    set the blend of sprite spr to x * jump
    updateStage()
  end repeat
  if the blend of sprite spr <> 100 then
    set the blend of sprite spr to 100
    updateStage()
  end if
end

on contentsFlash spr
  if spr > 20 then
    puppetSprite(spr, 1)
    set the ink of sprite spr to 2
    updateStage()
  end if
end

on ContentsFlashClear
  repeat with x = 21 to 31
    if the puppet of sprite x = 1 then
      set the ink of sprite x to 36
      updateStage()
      puppetSprite(x, 0)
      exit repeat
    end if
  end repeat
end

on parseContentsBtns spr
  global gCDName, gDirSep, gCurrChart, gCurrGlossary, gKnockBack, gBlendSpriteList
  if spr = 21 then
    go("Intro")
  else
    if spr = 22 then
      go("options")
      puppetSprite(6, 1)
      set the castNum of sprite 6 to 30
      set the visible of sprite 6 to 1
      updateStage()
    else
      if spr = 23 then
        go("PreEditorial")
      else
        if spr = 24 then
          cursor(4)
          go("Movie")
        else
          if spr = 25 then
            go("JPE")
          else
            if spr = 26 then
              go("JFE")
            else
              if spr = 27 then
                cursor(4)
                set the hilite of cast "ChartsMenu" to 0
                set the hilite of cast "ChartsLinear" to 1
                if gCurrChart = 0 then
                  set gCurrChart to 5
                end if
                set chartFile to item 2 of line gCurrChart of the text of cast "ChartsIndex"
                go("PreCharts")
                puppetSprite(4, 1)
                set the castNum of sprite 4 to the number of member chartFile
              else
                if spr = 28 then
                  set gCurrGlossary to 1
                  set the text of cast "HyperField" to " "
                  go("Glossary")
                  getGlossaryEntry()
                  puppetSprite(4, 1)
                  set the castNum of sprite 4 to 30
                  set the visible of sprite 4 to 1
                  updateStage()
                else
                  if spr = 29 then
                    cursor(4)
                    go("Credits")
                  else
                    if spr = 30 then
                      nothing()
                    else
                      if spr = 31 then
                        go("About")
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  set gKnockBack to 1
end

on interScript
  beep()
  nothing()
  dontPassEvent()
end
